2011-03-22  Veerapuram Varadhan  <v.varadhan@gmail.com>

	** Fixes #676368 - Patch by 0richardkk.novell@chiark.greenend.org.uk
	* OdbcConnection.cs: Make linking/unlinking of OdbcCommands thread safe.
	* OdbcCommand.cs: Check generation object from connection in order to 
	free the associated statement handle.
	
2010-12-07  Veerapuram Varadhan  <vvaradhan@novell.com>

	** Fixes #456234 - Patch by amc1999@gmail.com
	* OdbcDataReader.cs (GetValue): Handle SQL_NO_TOTAL sanely and 
	use corresponding Decoder.GetChars instead of Encoding.GetString.
	
2010-06-15 Jonathan Chambers  <joncham@gmail.com>

	* OdbcDataReader.cs: Remove unneeded cast on ref parameter

2009-07-15  Veerapuram Varadhan  <vvaradhan@novell.com>

	* OdbcParameter.cs (OdbcType): Return appropriate type from the typeMap.
	
2009-02-20  Veerapuram Varadhan  <vvaradhan@novell.com>

	* OdbcDataReader.cs (GetValue): Handle null image data.  Fixes ##419224
	Patch by John Mortlock <johnm@hlaustralia.com.au>.
	
2009-01-18  Gert Driesen  <drieseng@users.sourceforge.net>

	* OdbcDataReader.cs: Fixed GetBytes with limited length. Added reader
	state and argument checks.

2009-01-18  Gert Driesen  <drieseng@users.sourceforge.net>

	* OdbcCommand.cs: Do not allow negative CommandTimeout. Reject invalid
	value for CommandType and UpdatedRowSource. In Dispose, clear
	CommandText (2.0 only) and Parameters. Include method that is being
	executed in the exception messages for Connection and CommandText
	verification.

2009-01-03  Gert Driesen  <drieseng@users.sourceforge.net>

	* OdbcCommandBuilder.cs (QuoteIdentifier): Escape QuoteSuffix
	character(s) in unquoted identifier.

2008-12-30  Gert Driesen  <drieseng@users.sourceforge.net>

	* OdbcColumn.cs: Treat OdbcType.Numeric as decimal.
	* OdbcConnection.cs: Keep (weak) list of commands to allow us to
	dispose them (and free their corresponding statement handles) when
	the connection is closed. Fixed bug #341743.
	* OdbcCommand.cs: Add internal Unlink method that is invoked when the
	OdbcConnection is disposed, and which frees the statement handle.
	Modified ExecuteNonQuery helper to take CommandBehavior and rename
	freeHandle argument to createReader. Added CommandBehavior argument
	to ExecSQL. Added FreeStatement overload that takes an option to not
	perform an unlink. Fixes bug #3417434.

2008-12-30  Gert Driesen  <drieseng@users.sourceforge.net>

	* libodbc.cs: Add IdentifierQuoteChar to OdbcInfo.
	* OdbcCommandBuilder.cs: Return a zero-length string when QuotePrefix
	or QuoteSuffix are not set (or are set to null). Changing QuotePrefix
	or QuoteSuffix after a command has been generated should result in an
	InvalidOperationException. Implemented support for obtaining
	character(s) for quoting identifiers from specified connection.
	Modified generated SQL to match MS.
	* OdbcConnectionStringBuilder.cs: Improved special casing of Driver
	and Dsn keywords. Re-use implemenation of DbConnectionStringBuilder.
	Improved argument checks to match MS.

2008-10-09 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* OdbcDataReader.cs: apply patch from Steve ? that fixes bug #433741.
	GetBytes() was returning only the last byte.

2008-08-26  Veerapuram Varadhan  <vvaradhan@novell.com>

	Patch provided by Ernesto <equistango@gmail.com>
	* OdbcDataReader.cs: Don't call GetSchemaTable in the constructor
	instead just get column information.  Enhances performance of
	DataReader.
	
2008-08-26  Veerapuram Varadhan  <vvaradhan@novell.com>

	Patch provided by Ernesto <equistango@gmail.com>
	* OdbcParameter.cs (CopyValue): Handle Binary type along with
	VarBinary and Image. 
	
2008-07-06  Sebastien Pouliot  <sebastien@ximian.com>

	* OdbcDataReader.cs: Fix unneeded self-assignment for 'length'. Also
	fix a bad setter where "value = behavior" instead of "behavior = value"
	[Found using Gendarme ReviewSelfAssignmentRule]

2008-04-21  Gert Driesen  <drieseng@users.sourceforge.net>

	* OdbcParameterCollection.cs: Changed argument names to match MS.
	Code formatting.

2008-03-24  Gert Driesen  <drieseng@users.sourceforge.net>

	* OdbcTransaction.cs: Use internal CreateOdbcException method on
	OdbcConnection to create OdbcException.
	* OdbcException.cs: Added support for multiple OdbcError instances
	and fixed Message property on 2.0 profile.
	* OdbcCommand.cs: Use internal CreateOdbcException method on
	OdbcConnection to create OdbcException. Code formatting.
	* OdbcError.cs: Moved code to obtain ODBC error info to newly
	introduced CreateOdbcException on OdbcConnection. Code formatting.
	* OdbcDataReader.cs: Use internal CreateOdbcException method on
	OdbcTransaction to create OdbcException.
	* OdbcParameterCollection.cs: Removed obsolete Bind method.
	* OdbcConnection.cs: Added SafeDriver property that returns
	name of driver if available and a zero-length string otherwise.
	Use CreateOdbcException method to create OdbcException from ODBC
	error info. Added CreateOdbcException method to construct
	OdbcException from all available ODBC error info.
	* OdbcParameter.cs: Use internal CreateOdbcException method on
	OdbcConnection to create OdbcException.

2008-03-23  Gert Driesen  <drieseng@users.sourceforge.net>

	* OdbcErrorCollection.cs: Corcompare fixes and code formatting.
	* OdbcCommandBuilder.cs: Corcompare fixes and code formatting.
	* OdbcPermission.cs: Corcompare fixes and code formatting.
	* OdbcDataReader.cs: Corcompare fixes and code formatting.
	* OdbcParameterCollection.cs: Corcompare fixes and code formatting.
	* OdbcConnection.cs: Corcompare fixes and code formatting. Use
	unicode encoding in ChangeDatabase and GetInfo.
	* OdbcDataAdapter.cs: Corcompare fixes and code formatting.
	* OdbcParameter.cs: Corcompare fixes and code formatting.

2008-03-21  Gert Driesen  <drieseng@users.sourceforge.net>

	* libodbc.cs: Always use unicode version of ODBC functions. Fixes part
	of bug #372823.
	* OdbcTypeMap.cs: Fixed mapping for NChar, NText and NVarChar.
	* OdbcDataReader.cs (GetColumn): Use Unicode encoding to decode
	column name buffer.
	(GetDataTypeName): Use SQLColAttribute to determine type name of
	column.
	(GetValue): Fixed retrieving value of nchar column. When retrieving
	variable length unicode value, use Unicode encoding to decode buffer
	and remove trailing null characters. Fixes bug #364430.

2008-03-03  Veerapuram Varadhan  <vvaradhan@novell.com>

	** Fixes Bug#324025
	* OdbcDataReader (GetString): Use Convert.ToString() to return
	appropriate typed values.
	(GetValue): Fixes a regression. 
	
2008-03-03  Veerapuram Varadhan  <vvaradhan@novell.com>

	* OdbcCommandBuilder.cs: Clean up.
	
2008-03-03  Veerapuram Varadhan  <vvaradhan@novell.com>

	** Fixes Bug#340451 - patch provided by Ernesto Carrea
	<equistango@gmail.com>
	* OdbcConnection.cs (GetInfo): Trim the value to actual length
	returned by libodbc.
	
2008-03-03  Veerapuram Varadhan  <vvaradhan@novell.com>

	** Fixes from BNC#332809 - patch provided by Ernesto Carrea
	<equistango@gmail.com>
	* OdbcParameter.cs (Bind): Do not allocate buffer if value is
	DBNull.
	* OdbcTypeConverter.cs (InferFromValue): Incase of DBNull, do not
	throw exception, instead return NVarChar to match MS.NET
	implementation.
	
2008-03-03  Ankit Jain  <jankit@novell.com>

	* OdbcMetaDataCollectionNames.cs: Set the field values.

2008-02-26  Veerapuram Varadhan  <vvaradhan@novell.com>

	** Fixes BNC#364432.
	* OdbcParameter.cs: (Bind): Set StrLen parameter of
	SQLBindParameter to reflect NullData in case of DBNull.
	(CopyValue): If Value is DBNull.Value, just don't try any
	heroics. 
	
2008-02-25  Veerapuram Varadhan  <vvaradhan@novell.com>

	** Fixes BNC#364426.
	* OdbcDataReader.cs: (GetValue): Map OdbcType.Time to
	System.TimeSpan.  

	* OdbcTypeConverter.cs: (GetTypeMap): Map OdbcType.Time and
	SqlType.TIME to corresponding types. 

	* OdbcColumn.cs: -- ditto --
	
2008-02-20  Veerapuram Varadhan  <vvaradhan@novell.com>

	* OdbcDataReader.cs: (GetValue): Handle cases when certain 
	ODBC drivers return unexpected results.  Fixes #326740.  Patch 
	provided by Mark Junker <mjscod@gmx.de>.
	
2008-01-16  Veerapuram Varadhan  <vvaradhan@novell.com>

	* OdbcCommandBuilder.cs: Implemented 2.0 APIs and code
	restructuring. 
	
2007-10-28  Gert Driesen  <drieseng@users.sourceforge.net>

	* OdbcDataReader.cs: Code formatting, spaces to tabs.

2007-10-20  Gert Driesen  <drieseng@users.sourceforge.net>

	* OdbcCommand.cs: Added constant for default CommandTimeout, instead
	of using a magic number. Avoid unnecessary initialization. Fixed
	default value for DesignTimeVisible. Return zero-length string if
	CommandText is null. Spaces to tabs and code formatting.
	* OdbcError.cs: Fixed typo in exception message.
	* OdbcConnection.cs: Return zero-length string if ConnectionString is
	null. In getters for Database, DataSource and Driver return a
	zero-length string if connection is closed. In BeginTransaction and
	GetSchema throw InvalidOperationException if connection is closed.
	Added override for GetSchema (string, string []). Use string.Empty
	instead of "".
	* OdbcDataAdapter.cs: Avoid unnecessary initializations. Use direct
	assignment in IDbDataAdapter implementation. In default ctor, set
	SelectCommand to null.

2007-10-19  Gert Driesen  <drieseng@users.sourceforge.net>

	* OdbcTransaction.cs: Clear connection in Commit and Rollback.
	In IsolationLevel, throw IOE if transaction is no longer open.

2007-10-19  Gert Driesen  <drieseng@users.sourceforge.net>

	* OdbcTransaction.cs: Keep state of the transaction, and update it
	when performing commit or rollback. In Dispose (bool), only perform
	a rollback if transaction was not committed or rollback before.
	In Commit and Rollback, throw an InvalidOperationException if
	transaction is no longer open.

2007-10-19  Gert Driesen  <drieseng@users.sourceforge.net>

	* OdbcTransaction.cs: Use OdbcIsolationLevel enum value instead of
	magic numbers. For Snapshot isolation level, the attribute
	SQL_COPT_SS_TXN_ISOLATION must be used instead. When isolation level
	is Unspecified, then do not modify the isolation level at all and
	lazy initlization the IsolationLevel property. Modified exceptions
	for invalid / not supported isolation levels to match MS.
	* libodbc.cs: Added attribute for changing SQL Server specific
	connection option. Added enum for ODBC isolation level options.
	Added SQLGetConnectAttr method.

2007-10-19  Gert Driesen  <drieseng@users.sourceforge.net>

	* libodbc.cs: Spaces to tabs. Code formatting.
	* OdbcConnection.cs: Spaces to tabs. Code formatting.
	* OdbcTransaction.cs: Code formatting.

2007-10-19  Nagappan <anagappan@novell.com> 

	* OdbcCommandBuilder.cs, OdbcParameterCollection.cs: Code alignment.
	* OdbcDataReader.cs: Fixes numeric columns, bug # 332404.

2007-10-19  Nagappan <anagappan@novell.com> 

	* OdbcCommand.cs: (Clone): Implemented new method. Code alignment.

2007-10-12  Nagappan <anagappan@novell.com> 

	* OdbcDataReader.cs: Bug 332400 - ODBC and LONGBLOB columns. Thanks to
	  Ernesto Carrea <equistango@gmail.com> for the patch and the test case.

2007-10-08  Marek Safar <marek.safar@gmail.com> 

	* OdbcParameterCollection.cs (SetParameter): Fixed missing cast.

2007-09-27  Nagappan A <anagappan@novell.com> 

	* OdbcTransaction.cs: AutoCommit and BeginTransaction fix. Thanks to
	  Mads Bondo Dydensborg <mbd@dbc.dk> and Amc <amc1999@gmail.com> for
	  providing this patch.

2007-09-25  Nagappan A  <anagappan@novell.com>

	* OdbcParameter.cs (ResetOdbcType, ResetDbType): Implemented
	missing methods. 2.0 attribute fixes.

	* OdbcInfoMessageEventArgs.cs (Message, Errors, ToString):
	Implemented missing properties and methods. 2.0 attribute fixes.

	* OdbcConnection.cs (InfoMessage): Added public event and relevant
	private APIs. 2.0 attribute fixes.

	* OdbcConnectionStringBuilder.cs: 2.0 attribute fixes.

	* OdbcParameterCollection.cs (GetParameter, SetParameter):
	Implemented missing 2.0 APIs and 2.0 attribute fixes.

	* OdbcDataReader.cs (finalize): 2.0 compatibility fixes.

	* OdbcPermission.cs (Add): 2.0 compatibility fixes.

	* OdbcCommandBuilder.cs: 2.0 attribute fixes.

	* OdbcRowUpdatingEventArgs.cs (BaseCommand): Added 2.0 property.

	* OdbcCommand.cs: 2.0 attribute fixes.

	* OdbcException.cs: 2.0 attribute fixes.

2007-09-11  AMC  <amc1999@gmail.com>

	* OdbcDataReader.cs (GetPrimaryKeys): ODBC data reader can now
	properly handle "no-primary-keys" situation. Fixes bug # 82560.

2007-09-11  Nagappan A  <anagappan@novell.com>

	* OdbcConnectionStringBuilder.cs: Fixed Dsn DisplayName attribute.

2007-08-13  Nagappan A  <anagappan@novell.com>

	* OdbcMetaDataColumnNames.cs: Added new class.

	* OdbcMetaDataCollectionNames.cs: Added new class.

	* OdbcParameter.cs: 2.0 compatibility changes.

	* OdbcFactory.cs (CreateConnectionStringBuilder)
	(CreatePermission): Implemented new methods.

	* OdbcInfoMessageEventHandler.cs: 2.0 compatibility changes.

	* OdbcConnection.cs: 2.0 compatibility changes.
	(GetSchema): Added new overloaded methods.

	* OdbcConnectionStringBuilder.cs (Driver, Dsn): Added attributes
	as per 2.0 requirement.

	* OdbcDataReader.cs: 2.0 compatibility changes.

	* OdbcCommandBuilder.cs: 2.0 compatibility changes.

	* OdbcCommand.cs: 2.0 compatibility changes.

	* OdbcErrorCollection.cs (CopyTo): Implemented new overloaded
	method.

	* OdbcException.cs: In 2.0 DbException should be inherited instead
	of SystemException.

2007-07-31  Nagappan A  <anagappan@novell.com>

	* OdbcCommand.cs (ExecSQL): Thanks to amc1999@gmail.com (amc) for
	  providing the patch, Fixes bug # 82135. ODBC SQLExecDirect
	  error. Delete where no-data-found fails.

	* OdbcCommandBuilder.cs: Removed bogus TODO.
	  Fixed 2.0 missing attributes

	* libodbc.cs: Added new libodbc global constant SQL_NTS.

	* OdbcCommand.cs (ExecSQL): Thanks to amc1999@gmail.com (amc) for
	  providing the patch, Fixes bug # 82191. ODBC command UTF8
	  error. SQL failed with UTF8 symbols in query.
	  Removed bogus TODO.
	  Fixed 2.0 missing attributes

2007-07-22  Nagappan A  <anagappan@novell.com>

	* OdbcDataAdapter.cs: Fixed compilation warning.

	* OdbcTransaction.cs: Fixed compilation warning.

2007-06-30  Gert Driesen  <drieseng@users.sourceforge.net>

	* OdbcDataAdapter.cs: Only override Dispose on 1.0 profile. Added
	stub for ICloneable.Clone.
	* OdbcTransaction.cs: Dispose should be explicit interface impl., not
	public. Connection is also public on 2.0 profile.

2007-06-21  Nagappan A  <anagappan@novell.com>

	* OdbcConnectionStringBuilder.cs: Added new file with the basic
	work of Nidhi Rawal (rawalnidhi_rawal@yahoo.com).

	* OdbcDataReader.cs (GetValue): Patch for varchar longer than 255
	characters, by Mads Bondo Dydensborg <mbd@dbc.dk>.

	* OdbcConnection.cs: Fixed compiler warning.

2007-06-06  Amit Biswas <amit@amitbiswas.com>

	* OdbcParameter.cs (OdbcParameter ()): Changed default values in the constructor
	
	* OdbcParameterCollection.cs (AddRange (Array values)): Implemented missing method
	(Add): Corrected bug related to default parameter names
	(Insert): Added check for valid index values
	(Contains): Corrected bug for case sensitivity
	(IndexOf): Corrected bug for case sensitivity
	(IndexOf): Corrected bug in comparing parameter names
	(Remove): Added check for non existing parameters
	(AddRange (OdbcParameter): Implemented missing method
	(AddRange (Array values): Implemented missing method
	(Insert (int index, OdbcParameter value)): Implemented missing method
	(Insert (int index, object value)): Implemented missing method
	(AddWithValue (string parameterName, Object value)): Implemented missing method
	(Remove (OdbcParameter value)): Implemented missing method
	(Contains (OdbcParameter value)): Implemented missing method
	(CopyTo (OdbcParameter [] array, int index)): Implemented missing method

2007-05-30  Nagappan A  <anagappan@novell.com>

	* OdbcDataReader.cs (GetValue): Adds nano seconds as tickcs from
	the received buffer.

2007-05-25  Nagappan A  <anagappan@novell.com>

	* OdbcDataReader.cs (GetValue): Sybase returns the fraction values
	in nano seconds, but DateTime expects the value in milliseconds,
	so the conversion.

2007-05-04  Nagappan A  <anagappan@novell.com>

	* libodbc.cs: Wrong ODBC API definitions (using ints instead of
	shorts) - Fixes bug 81306. Thanks to will.mooar@tait.co.nz and
	tausq@debian.org.

	* OdbcDataReader.cs: Wrong ODBC API definitions (using ints
	instead of shorts) - Fixes bug 81306. Thanks to
	will.mooar@tait.co.nz and tausq@debian.org.

2007-02-09  Nagappan A  <anagappan@novell.com>

	* OdbcDataReader.cs (GetDecimal): Implemented new API.

2007-01-08  Nagappan A  <anagappan@novell.com>

	* OdbcFactory.cs: Fixed compilation warning.

	* OdbcCategoryAttribute.cs (Category): Implemented missing
	property.

	* OdbcParameterCollection.cs: Fixed compilation warning.

	* OdbcCommandBuilder.cs (GetInsertCommand, GetUpdateCommand)
	(GetDeleteCommand): Implemented overloaded method.

	* OdbcTransaction.cs: Modified partial content of DOS format file
	to UNIX format.

2006-07-13  Senganal T  <tsenganal@novell.com>

	* OdbcTransaction.cs OdbcCommand.cs OdbcConnectionFactory.cs 
	OdbcPermission.cs OdbcDataReader.cs OdbcParameterCollection.cs 
	OdbcConnection.cs OdbcFactory.cs OdbcParameter.cs :
		2.0 Api fixes

2006-05-31  Gert Driesen  <drieseng@users.sourceforge.net>

	* OdbcErrorCollection.cs: Removed explicit interface implementation 
	of IEnumerable.GetEnumerator ().
	* OdbcCommand.cs: Removed destructor as the destructor in
	System.ComponentModel.Component already calls the Dispose method.
	Removed explicit interface implemenation of members that are 
	implement by public members.
	* OdbcDataReader.cs: Removed explicit interface implemenation of
	IDataRecord.GetData.

2006-05-24  Senganal T <tsenganal@novell.com>
       
	* OdbcColumn.cs :
		- Added IsVariableSizeType : Handle types with variable datasize
	* OdbcTypeConverter.cs : map LongVarBinary to Image
	* OdbcDataReader.cs :
		- GetValue () : Handle Text,Image datatypes differently. Only allocate
		storage for the data contained and not for MaxLength. Fixes #78234

2006-05-09  Senganal T  <tsenganal@novell.com>

	* OdbcConnection.cs : Implemented ChangeDatabase Method
	* libodbc.cs : Added value for CurrentCatalog in OdbcConnectionAttribute 

2006-02-17  Chris Toshok  <toshok@ximian.com>

	* OdbcDataReader.cs: remove VisibleFieldCount property.

2005-11-21  Senganal T <tsenganal@novell.com>

	* OdbcTransaction.cs
	* OdbcCommandBuilder.cs
	* OdbcParameterCollection.cs
	* OdbcDataReader.cs
	* OdbcFactory.cs
	* OdbcDataAdapter.cs
	* OdbcParameter.cs
	
	Added stubs and other changes for ADO.NET 2.0 compatibility

2005-10-14  Senganal T <tsenganal@novell.com>

	* OdbcColumn.cs : Changed the mapping of OdbcType.Char to string
	instead of char. Fixes bug #67269

2005-10-14  Senganal T <tsenganal@novell.com>

	* OdbcDataReader.cs: Added Text and NText datatypes to the list
	of datatypes checked by GetValue () method. Fixes bug #75032

2005-10-14  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcDataReader.cs (GetValue): Use SQL_CHAR for Numeric as
	temporary fix.

	* OdbcParameter.cs (CopyValue): Add support for Numeric & Decimal
	parameters.

2005-10-08  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcCommand.cs (BindParameters): Copy the parameter Value after
	binding.

	* OdbcParameter.cs: re-implemented the native buffer handling and
	odbc type handling.

	* NativeBuffer.cs: A native buffer class to hold pointer to native
	memory.

	* OdbcTypeMap.cs (OdbcTypeMap): structure to hold different odbc
	types and the default mapping.

	* OdbcTypeConverter.cs: Simplified mapping between different odbc
	types using switch-case.

	* libodbc.cs (SQLBindParameter): use only one entry point and use
	IntPtr instead of ref.

2005-08-20  Gert Driesen  <drieseng@users.sourceforge.net>

	* OdbcDataReader.cs: Marked GetPrimaryKeysBySQLStatistics unsafe.
	This fixes the build on Windows (using csc).

2005-08-09  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcDataReader.cs: GetSchemaTable (): set values for the column
	attributes using SQLColAttribute. If SQLPrimaryKeys does not
	yeild, try SQLStatistics. Optimized primary key logic.

	* libodbc.cs: Added api SQLStatistics and constants.

	* OdbcParameter.cs: setBuffer (): allocate a short int buffer for
	OdbcType.SmallInt. fixes bug #75600.

2005-08-08  Gert Driesen  <drieseng@users.sourceforge.net>

	* OdbcConnection.cs: Marked Init helper method private.
	* OdbcCommand.cs: Marked BindParameters helper method private.

2005-08-08  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcDataReader.cs: Implemented Dispose pattern. Cache
	schematable for same result set. don't free command's statements
	if the command is prepared.

	* OdbcConnection.cs: Open (): set disposed to false so that close
	will be called in Dispose.

	* OdbcCommand.cs:
	- Prepare (): Split SQLPrepare and SQLBind so that
	already prepared statements can be reused with new parameter
	values.
	- ExecSQL (): create new statement handle, if not prepared
	and there are no parameters. if there are parameters, prepare and
	use.
	- Implemented Dispose pattern
	- Streamlined the allocation and de-allocation of statement
	handles.

2005-08-05  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcDataReader.cs: RecordsAffected: get value from command.
	GetSchemaTable (): set IsExpression based on BaseTableName. set
	AllowDBNull to false if the column is PK.

	* OdbcCommand.cs: correct UpdatedRowSource is returned. whitespace
	changes to conform to standard.

	* OdbcCommandBuilder.cs: Implemented.

	* OdbcParameter.cs: Direction is set to Input by default.

2005-07-22  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcParameter.cs: updated attributes & attribute descriptions to
	match with masterinfos.

	* OdbcDataReader.cs: NextRow (): made private.

2005-07-21  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcDataReader.cs: GetValue (): added case for OdbcType.Bit. and
	Formatting corrections. Fixes bug #75574.

2005-07-07  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcTypeConverter.cs: ConvertToSqlType & ConvertToSqlCType: map
	VarChar to SQL_C_CHAR and SQL_VARCHAR respective instead of WCHAR
	and WVARCHAR as temporary fix.

	* OdbcParameter.cs: setBuffer: string types need not be quoted.

2005-06-28  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcDataReader.cs: GetPrimaryKeys (): use the length indicator
	for GetString, otherwise, it creates a string of length 255. Use
	ArrayList for keys as the columns are different from the selected
	columns. fixes bug #75263.

2005-06-09  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcDataReader.cs: GetValue (): return decimal in case of odbc
	type Numeric. Move the temp buffer logic inside.

	* OdbcTypeConverter.cs: map SQL_TYPE.NUMERIC to SQL_C_TYPE.CHAR by
	now, since PgSql driver seems not to accept NUMERIC c type. Other
	database anyway, provides NUMERIC datatype as DECIMAL.

2005-05-31  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcParameter.cs: setBuffer (): for numeric type, the buffer
	parameter should be a packed decimal struct. fixes bug #75041.

2005-04-05  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcParameter.cs: SqlBindParameter requires the last parameter
	to be a ref.
	* libodbc.cs: API change for above.

2005-04-04  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcDataReader.cs: Ignore BaseTableName & BaseColumnName
	properties while building Schema information as most drivers
	ignores these properties. e.g. PostgreSQL.

2005-03-24  Sureshkumar T  <tsureshkumar@novell.com>
	    Appasamy <appasamy@rediffmail.com>

	* OdbcColumn.cs: IsStringType: OdbcType.Char is also of type
	String.
	* OdbcDataReader.cs: GetSchemaTable: Get Additional info using
	SQLColAttribute. Don't pad with spaces in GetColAttributeStr.

2005-03-24  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcDataReader.cs:
	- GetValue: Decode only outsize length for SQL_C_TYPE.CHAR type in
	SQLGetData.
	- GetOrdinal: Perform case insensitive lookup if sensitive lookup
	fails.

2005-03-22  Sureshkumar T  <tsureshkumar@novell.com>
            Appsamy <appasamy@rediffmail.com>

	* libodbc.cs (System.Data.Odbc): Added enum FieldIdentifier. Added
	library functions SQLPrimaryKeys, SQLBindCol and SQLColAttribute.

	* OdbcDataReader.cs: Implemented GetPrimaryKeys to get the primary
	keys associated with resultset using SQLPrimaryKeys.

2005-03-15  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcConnection.cs: re-throw error on exception in Open method.

2005-03-11  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcConnection.cs : notify state change through event. clean up
	handles in case any exception while opening a connection. NET_2_0
	uses base class's OnStateChange handler.

2005-03-10  Sureshkumar T  <tsureshkumar@novell.com>

	Migrated core classes to derive from ProviderBase instead of
	implementing IDb* interfaces. Most part of these files have been
	branched with #if NET_2_0/ONLY_1_1. Make sure any changes works
	with both the profiles.

	* OdbcFactory.cs: Concrete Factory for DbProviderFactory. Factory
	to generate Connection,Command,etc.

	* OdbcConnectionFactory.cs: Concrete factory for DbConnectionFactory.

	* OdbcTransaction.cs: migration and overrides.
	* OdbcCommandBuilder.cs: migration and overrides.
	* OdbcDataReader.cs: --do--. no command behavior member as it will
	be maintained in base provider class.
	* OdbcParameterCollection.cs: --do--. Now, local ArrayList is not
	maintained here, instead it is in base class. Most of the methods
	which operated on this list are not needed in NET_2_0.
	* OdbcConnection.cs: Migration. connectionString is maintained in
	DbConnectionBase class.
	* OdbcParameter.cs: Migration. Many of the local members like
	value,sourceColumn are maintained in DbParameterBase.
	* OdbcCommand.cs: Migration. commandText,timeout and
	commandTimeOut are maintained in DbCommandBase class.

2005-03-10  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcType.cs: Added enums for SQL_TYPE & SQL_C_TYPE.
	
	* libodbc.cs: Accept SQL_C_TYPE for driver
	parameters. SQLBindParameter takes two parameters SQL_TYPE and
	SQL_C_TYPE. This caused the whole lot of changes done in this
	revision.
	
	* OdbcParameter.cs: Set default values of OdbcType & DbType. Pass
	mapped SQL_TYPE and SQL_C_TYPE to SQLBindParameter. Increase
	buffer size by 2 for additional ' chars.
	
	* OdbcTypeConverter.cs: Added class to convert between OdbcType,
	SQL_TYPE, SQL_C_TYPE.
	
	* OdbcColumn.cs: Added private members for SQL_TYPE and
	SQL_C_TYPE. conversion from/to odbctype to/from SQL_TYPE is done
	through OdbcTypeConverter class.
	
	* OdbcDataReader.cs: use OdbcColumn's SQL_C_TYPE member. It keeps
	track of default mapping between odbctype, SQL_TYPE and
	SQL_C_TYPE. Move dataTableSchema.AcceptChanges inside if condition
	to avoid null reference exception.

2005-02-04  Sureshkumar T  <tsureshkumar@novell.com>
	    Appasamy <appasamy@rediffmail.com>

	* OdbcConnection.cs: Implemented properties database, datasource,
	serverversion and driver.
	* libodbc.cs: Added type OdbcInfo and native call SQLGetInfo.

2005-01-20  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcDataReader.cs: case for type OdbcType.Double added in
	GetValue.  fixes bug #71173.

	Thanks to patch given by "Appasamy T" <appasamy@rediffmail.com>

2005-01-19  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcType.cs: Change enum values for compatiability with MS.NET.
	* libodbc.cs: Change enum values for compatiability with
	MS.NET. Change calls into driver with native type.
	* OdbcDataReader.cs: Change enum values for compatiability with
	MS.NET. Change calls from/into driver with native type.

2005-01-18  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcDataReader.cs: GetOrdinal need not check for
	currentRow. Return -1 if column name is not found.

	fixes bug #71261. Thanks to patch given by "Appasamy T"
	<appasamy@rediffmail.com>.

2005-01-13  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcDataReader.cs: Implement NextResultSet for multiple result
	set queries. 
	
	* OdbcDataReader.cs: build column schema once creating reader and
	then for each Next result set. Thanks to
	sebastien.robitaille@croesus.com (Sebastien Robitaille) for
	pointing out this optimization (bugzilla #70530).

	* libodbc.cs: Added library calls SQLFreeStmt and SQLMoreResults
	for mutiple resultsets.

2005-01-10  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcDataReader.cs: Connection has to be closed only after
	Statement handle is freed. fixes bug #70048.

2005-01-07  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcDataReader.cs: Pass OdbcCType.SignedBigInt for accessing big
	int columns.

	* OdbcType.cs: Added a new enum for Odbc C DataTypes. This should
	essentially be passed to drivers, since the public OdbcType types
	differs from types expected in drivers in some cases.

	* libodbc.cs : Added a ODBC method which takes OdbcCType
	enumeration for SQLGetData for BigInt fields.

	fixes bug #65342.

2004-12-28  Duncan Mak  <duncan@ximian.com>

	* libodbc.cs: Change all the DllImport attributes to point to
	"odbc32.dll" instead of "odbc32", because /etc/mono/config lists
	"odbc32.dll" (all other entries in the file have the .dll suffix
	as well, for consistency's sake, let's rename it here.)

	This fixes #70727.
	
2004-12-03  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcParameter.cs: Fixed a null reference exception when a
	parameter is created and its value is not set. #68750.

2004-11-26  Sureshkumar T  <tsureshkumar@novell.com>

	* OdbcParameter.cs: Fixed Parameter Size property as well as
	insufficient buffer errors. bug #68749.

2004-09-14  Sebastien Pouliot  <sebastien@ximian.com>

	* OdbcPermission.cs: Added internal constructor accepting an Odbc
	PermissionAttribute parameter (using base class protected ctor).
	* OdbcPermissionAttribute.cs: Copy now use the new OdbcPermission
	constructor.

2004-09-13  Sebastien Pouliot  <sebastien@ximian.com>

	* OdbcPermission.cs: Mostly completed (needs tests).
	* OdbcPermissionAttribute.cs: Completed.

2004-08-31 Umadevi S (sumadevi@novell.com)
	* OdbcDataReader.cs - Fixed Decimal parsing

2004-08-30 Umadevi S (sumadevi@novell.com)
	* OdbcType.cs - removed inheritance from short.

2004-08-27 Sureshkumar T (tsureshkumar@novell.com)
	* OdbcDataReader.cs - fixed bug #63539 - TINYINT ODBC datatype is converted into System.Byte

2004-08-26 Sureshkumar T (tsureshkumar@novell.com)
	* OdbcDataReader.cs - Date & DateTime GetValue fixed. 
			      GetBytes ordinal parameter passing fixed for BINARY in GetValue.

2004-08-20 Sureshkumar T (tsureshkumar@novell.com)
	* OdbcConnection.cs - correct handles are passed to OdbcError exception to trap the correct error

2004-08-04 Umadevi S (sumadevi@novell.com)
        * OdbcDataReader.cs - Fixed bug 61832 - Column names were not filled, due to which name based lookup of columns failed.
                                                                                                  

2004-08-04 Umadevi S (sumadevi@novell.com)
        * OdbcDataReader.cs - Fixed bug 61405 - Handling smallint column type.

2004-07-30  Sureshkumar T (tsureshkumar@novell.com)
        * OdbcCommand.cs: ExecuteNonQuery Closed statement handle to fix memory leak
        * OdbcDataReader.cs: Closed statement handle to fix memory leak
			     Removed SQLState login in GetBytes coz OdbcError provides the same.
				    
2004-07-29 Umadevi S (sumadevi@novell.com)
        * OdbcCommand.cs - Fixed bug 62046. ExecuteNonQuery implemented correctly
                                                                                                    

2004-07-28 Umadevi S (sumadevi@novell.com)
        * OdbcParameter.cs - fixed bug 61968. String values passed with quotes
                                                                                                 

2004-07-07 Umadevi S (sumadevi@novell.com)
        * OdbcConnection.cs - Allowed Close to be called multiple times
                            - Implementation of Dispose method

2004-07-07 Umadevi S (sumadevi@novell.com)
        * OdbcCommand.cs : fixed set method for Transaction
                                                          
2004-07-01  Sureshkumar T (tsureshkumar@novell.com)
	* OdbcCommand.cs   : fixed reader problem with ExecuteScalar

2004-06-23  Sureshkumar T (tsureshkumar@novell.com)
        * OdbcConnection.cs: Fix: Moved env allocation to Open method. 
			     Disconnection & freeing handles are done in Close 
			     method to avoid simultaneous connections.
	* libodbc.cs	   : Added constants for odbc version.
				    
2004-06-16  Gert Driesen <drieseng@users.sourceforge.net>

	* OdbcError.cs: fixed serialization compatibility with MS.NET
	* OdbcErrorCollection.cs: fixed serialization compatibility with
	MS.NET
	* OdbcException.cs: fixed serialization compatibility with MS.NET

2004-06-16  Sureshkumar T (tsureshkumar@novell.com)
	* OdbcDataReader.cs: Added GetValue support for Sql Binary type to return byte array.
			     Implemented GetBytes method.
	* libodbc.cs	   : Added enums, constants & imports for above fix.

2004-06-13  Gert Driesen <drieseng@users.sourceforge.net>

	* OdbcDataReader.cs: changed GetData method to return IDataReader
	to match MS.NET

2004-06-09  Sureshkumar T (tsureshkumar@novell.com)
        * OdbcDataReader.cs: Removed checking of currentRow in GetName
          method

2004-06-04  Gert Driesen <drieseng@users.sourceforge.net>

	* OdbcPermission.cs: moved Obsolete attribute to correct
	ctor

2004-06-02  Sureshkumar T (tsureshkumar@novell.com)
       
	* OdbcDataReader.cs: Implemented GetByte method. Fixed bug #58820

2004-06-02  Gert Driesen <drieseng@users.sourceforge.net>

        * OdbcParameter.cs: added missing attributes
        * OdbcPermission.cs: added missing attributes
        * OdbcConnection.cs: fixes attribute, added missing attributes
        * OdbcInfoMessageEventArgs.cs: removed extra properties, fixed
        API compatibility with MS.NET
        * OdbcCommandBuilder.cs: use correct attributes

2004-05-20  Gert Driesen (drieseng@users.sourceforge.net)

        *  OdbcPermissionAttribute.cs: change AllowMultiple and
        Inherited to match .NET

2004-05-17 Umadevi S (sumadevi@novell.com)
	* OdbcPermissionAttribute, OdbcPermission.cs - fixed missing methods

2004-05-17 Gert Driesen (drieseng@users.sourceforge.net)
	* OdbcCategoryAttribute.cs: fixed namespace
	* OdbcDataAdapter.cs: removed extra attributes
	* OdbcDescriptionAttribute.cs: fixed namespace

2004-05-14 Umadevi S (sumadevi@novell.com)
        * OdbcParameterConverter.cs -Added 
	* OdbcParameter.cs - Added some attributes	

2004-05-14 Umadevi S (sumadevi@novell.com)
        * OdbcDataAdapter.cs - Added Attributes

2004-05-14 Umadevi S (sumadevi@novell.com)
        * OdbcConnection.cs - Added Attributes

2004-05-14 Umadevi S (sumadevi@novell.com)
        * OdbcCommand.cs - Added Attributes

2004-05-14 Umadevi S (sumadevi@novell.com)
        * OdbcDataReader.cs - Added Attributes

2004-05-14 Umadevi S (sumadevi@novell.com)
        * Added Classes OdbcCategoryAttribute.cs, OdbcDescriptionAttribute.cs

2004-05-14 Umadevi S (sumadevi@novell.com)
	* Added Class OdbcCommandBuilder.cs

2004-05-14 Umadevi S (sumadevi@novell.com)
        * Added classes OdbcInfoMessageEventArgs.cs - with stubs
	* Added classes OdbcInfoMessageEventInfo.cs	

2004-05-14 Umadevi S (sumadevi@novell.com)
	* Added classes OdbcPermission.cs, OdbcPermissionAttribute.cs - with stubs

2004-05-09  Gert Driesen (drieseng@users.sourceforge.net)
	* OdbcException.cs : removed ErrorCode property, fixing signature
	* OdbcErrorCollection.cs : added internal ctor, reduced 
	accessibility of Add method to internal
	* OdbcCommand.cs: marked hstmt field private, remove setters for
	Parameters property
	* OdbcDataReader.cs: Added GetDate method, renamed GetTimeSpan to
	GetTime to match MS.NET, added HasRows stub

2004-05-09  Gert Driesen (drieseng@users.sourceforge.net)
	* OdbcError.cs: 
	* OdbcErrorCollection.cs:
	* OdbcException.cs: fixed linefeeds to DOS to match other
	sources in System.Data.Odbc

2004-05-09  Gert Driesen (drieseng@users.sourceforge.net)
	* OdbcCommand.cs: No longer use OdbcConnection.Datareader, in order 
	to fix signature of OdbcConnection
	* OdbcDataReader.cs: No longer use ODbcConnection.Datareader, in 
	order to fix signature of OdbcConnection
	* OdbcConnection.cs: Signature fixes: removed DataReader property, 
	added setter for ConnectionTimeout, made transaction internal
	* OdbcParameter.cs: reduced accessibility of Bind method to 
	internal, added setter for IsNullable
	* OdbcParameterCollection.cs: made default ctor and Bind method
	internal

2004-05-09  Gert Driesen (drieseng@users.sourceforge.net)
	* OdbcCommand.cs: fixed linefeeds to DOS to match other sources
	in System.Data.Odbc

2004-05-09  Gert Driesen (drieseng@users.sourceforge.net)
	* OdbcTransaction.cs: fixed signature to match MS.NET

2004-05-09  Gert Driesen (drieseng@users.sourceforge.net)
	* OdbcType.cs: fixed typo UniqueIndetifier
	* OdbcColumn.cs : fixed typo UniqueIndetifier

2004-05-09  Gert Driesen (drieseng@users.sourceforge.net)
	* OdbcType.cs: fixed linefeeds to DOS to match other sources
	in System.Data.Odbc

2003-12-01  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* OdbcTransaction.cs: applied patch from Jeff Seifert that makes
	this class implement IDbTransaction interface.

2002-11-01  Daniel Morgan <danmorg@sc.rr.com>

	* OdbcDataReader.cs: - uncommented code, but I put a FIXME:
	according to Brian, this does not work on MS .NET however, we need it
	for Mono for now. schemaRow.AcceptChanges(),
	- implement IEnumerable.GetEnumerator()
    
	* libodbc.cs: changed the DllImport from "odbc32.dll" to "odbc32"
    
2002-10-21  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* ChangeLog: added.
	* OdbcError.cs:
	* OdbcException.cs: added dummy implementation for these missing
	classes.

